<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>
; inspiration for this implementation was found in  
; http://www.csounds.com/journal/issue7/commandLineFXProcessing.html

sr      =  44100
ksmps   =  1
nchnls  =  2
0dbfs   =  1

    instr Setup
  ilen	filelen "$WavFile"
	event_i	"i", "Effect", 0, ilen + $DecayTime.
	turnoff   
    endin


    instr Effect 
  a1, a2    soundin   "$WavFile"
	    denorm    a1
	    denorm    a2
  aL, aR    freeverb  a1, a2, $RoomSize., $HFDamp., sr, 0
	    outs      a1 + aL * $Mix., a2 + aR * $Mix.
    endin
</CsInstruments>
<CsScore>
i "Setup" 0 0.0001
e
</CsScore>
</CsoundSynthesizer>
