;WRITTEN BY IAIN MCCURDY, 2008

<CsoundSynthesizer>

<CsOptions>
-odevaudio -b400
</CsOptions>

<CsInstruments>

sr 	= 	44100  
kr 	= 	44100
ksmps 	= 	1
nchnls 	= 	2

FLcolor	255,255,255,0,0,0
		FLpanel	" ",1045, 330, 0, 0


;                                             				ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE |  I  | STARTTIM | IDUR |  p4
gkOnOff,ihOnOff	FLbutton	"On/Off",				1,    0,     2,    100,     30,    0,  0,   0,        1,     0,       -1
FLsetColor2	255,50,50,ihOnOff	;RED
gkRndPitches,ihRndPitches	FLbutton	"Randomise Pitches",	1,    0,     1,    100,     40,  842,220,   0,      102,     0,       0.001

;COUNTERS						MIN | MAX | STEP1 | STEP2 | TYPE | WIDTH | HEIGHT | POS_X | POS_Y | IOPCODE
gkTempo,ihTempo 	FLcount		"Tempo",	1,    999,    1,     10,     21,   100,     20,     100,      0,      -1

;BORDERS				ITYPE, IFONT, ISIZE, IWIDTH, IHEIGHT, IX, IY
ih		 	FLbox  	" ", 	5,        9,    15,    80,    183,     0, 48		;DRAW A BOX AROUND EACH GROUP OF 4 BUTTONS
ih		 	FLbox  	" ", 	5,        9,    15,    80,    183,    80, 48            ;DRAW A BOX AROUND EACH GROUP OF 4 BUTTONS
ih		 	FLbox  	" ", 	5,        9,    15,    80,    183,   160, 48            ;DRAW A BOX AROUND EACH GROUP OF 4 BUTTONS
ih		 	FLbox  	" ", 	5,        9,    15,    80,    183,   240, 48            ;DRAW A BOX AROUND EACH GROUP OF 4 BUTTONS
ih		 	FLbox  	" ", 	5,        9,    15,    80,    183,   320, 48            ;DRAW A BOX AROUND EACH GROUP OF 4 BUTTONS
ih		 	FLbox  	" ", 	5,        9,    15,    80,    183,   400, 48            ;DRAW A BOX AROUND EACH GROUP OF 4 BUTTONS
ih		 	FLbox  	" ", 	5,        9,    15,    80,    183,   480, 48            ;DRAW A BOX AROUND EACH GROUP OF 4 BUTTONS
ih		 	FLbox  	" ", 	5,        9,    15,    80,    183,   560, 48            ;DRAW A BOX AROUND EACH GROUP OF 4 BUTTONS

;TEXT BOXES						TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"Gain",			1,      5,     13,     90,     12,   648,  7
ih		 	FLbox  	"Transpose",		1,      5,     13,     90,     12,   848, 35
ih		 	FLbox  	"Delay (0-0.1 s.)",	1,      5,     13,     90,     12,   948, 30
ih		 	FLbox  	"Cycle Range",		1,      5,     13,     90,     12,   748, 35
ih		 	FLbox  	"1",			1,      5,     13,      4,     12,     4, 35
ih		 	FLbox  	"2",			1,      5,     13,      4,     12,    84, 35
ih		 	FLbox  	"3",			1,      5,     13,      4,     12,   164, 35
ih		 	FLbox  	"4",			1,      5,     13,      4,     12,   244, 35
ih		 	FLbox  	"5",			1,      5,     13,      4,     12,   324, 35
ih		 	FLbox  	"6",			1,      5,     13,      4,     12,   404, 35
ih		 	FLbox  	"7",			1,      5,     13,      4,     12,   484, 35
ih		 	FLbox  	"8",			1,      5,     13,      4,     12,   564, 35

;				            			MIN  | MAX | EXP | TYPE | DISP | WIDTH | HEIGHT | X | Y
gkMasterGain, ihMasterGain	FLslider 	"Master",	0,      1,    0,    3,     -1,   100,      12,  642,  24

iy	init	50
#define	COUNT	#1#

#define	ROW	#
gk$COUNT,gih$COUNT_1	FLbutton	" ",			1,    0,      4,     20,     20,      2, iy,  0,     9+$COUNT,    0,        0,     1
gk$COUNT,gih$COUNT_2	FLbutton	" ",			1,    0,      4,     20,     20,     22, iy,  0,     9+$COUNT,    0,        0,     2
gk$COUNT,gih$COUNT_3	FLbutton	" ",			1,    0,      4,     20,     20,     42, iy,  0,     9+$COUNT,    0,        0,     3
gk$COUNT,gih$COUNT_4	FLbutton	" ",			1,    0,      4,     20,     20,     62, iy,  0,     9+$COUNT,    0,        0,     4
gk$COUNT,gih$COUNT_5	FLbutton	" ",			1,    0,      4,     20,     20,     82, iy,  0,     9+$COUNT,    0,        0,     5
gk$COUNT,gih$COUNT_6	FLbutton	" ",			1,    0,      4,     20,     20,    102, iy,  0,     9+$COUNT,    0,        0,     6
gk$COUNT,gih$COUNT_7	FLbutton	" ",			1,    0,      4,     20,     20,    122, iy,  0,     9+$COUNT,    0,        0,     7
gk$COUNT,gih$COUNT_8	FLbutton	" ",			1,    0,      4,     20,     20,    142, iy,  0,     9+$COUNT,    0,        0,     8
gk$COUNT,gih$COUNT_9	FLbutton	" ",			1,    0,      4,     20,     20,    162, iy,  0,     9+$COUNT,    0,        0,     9
gk$COUNT,gih$COUNT_10	FLbutton	" ",			1,    0,      4,     20,     20,    182, iy,  0,     9+$COUNT,    0,        0,    10
gk$COUNT,gih$COUNT_11	FLbutton	" ",			1,    0,      4,     20,     20,    202, iy,  0,     9+$COUNT,    0,        0,    11
gk$COUNT,gih$COUNT_12	FLbutton	" ",			1,    0,      4,     20,     20,    222, iy,  0,     9+$COUNT,    0,        0,    12
gk$COUNT,gih$COUNT_13	FLbutton	" ",			1,    0,      4,     20,     20,    242, iy,  0,     9+$COUNT,    0,        0,    13
gk$COUNT,gih$COUNT_14	FLbutton	" ",			1,    0,      4,     20,     20,    262, iy,  0,     9+$COUNT,    0,        0,    14
gk$COUNT,gih$COUNT_15	FLbutton	" ",			1,    0,      4,     20,     20,    282, iy,  0,     9+$COUNT,    0,        0,    15
gk$COUNT,gih$COUNT_16	FLbutton	" ",			1,    0,      4,     20,     20,    302, iy,  0,     9+$COUNT,    0,        0,    16
gk$COUNT,gih$COUNT_17	FLbutton	" ",			1,    0,      4,     20,     20,    322, iy,  0,     9+$COUNT,    0,        0,    17
gk$COUNT,gih$COUNT_18	FLbutton	" ",			1,    0,      4,     20,     20,    342, iy,  0,     9+$COUNT,    0,        0,    18
gk$COUNT,gih$COUNT_19	FLbutton	" ",			1,    0,      4,     20,     20,    362, iy,  0,     9+$COUNT,    0,        0,    19
gk$COUNT,gih$COUNT_20	FLbutton	" ",			1,    0,      4,     20,     20,    382, iy,  0,     9+$COUNT,    0,        0,    20
gk$COUNT,gih$COUNT_21	FLbutton	" ",			1,    0,      4,     20,     20,    402, iy,  0,     9+$COUNT,    0,        0,    21
gk$COUNT,gih$COUNT_22	FLbutton	" ",			1,    0,      4,     20,     20,    422, iy,  0,     9+$COUNT,    0,        0,    22
gk$COUNT,gih$COUNT_23	FLbutton	" ",			1,    0,      4,     20,     20,    442, iy,  0,     9+$COUNT,    0,        0,    23
gk$COUNT,gih$COUNT_24	FLbutton	" ",			1,    0,      4,     20,     20,    462, iy,  0,     9+$COUNT,    0,        0,    24
gk$COUNT,gih$COUNT_25	FLbutton	" ",			1,    0,      4,     20,     20,    482, iy,  0,     9+$COUNT,    0,        0,    25
gk$COUNT,gih$COUNT_26	FLbutton	" ",			1,    0,      4,     20,     20,    502, iy,  0,     9+$COUNT,    0,        0,    26
gk$COUNT,gih$COUNT_27	FLbutton	" ",			1,    0,      4,     20,     20,    522, iy,  0,     9+$COUNT,    0,        0,    27
gk$COUNT,gih$COUNT_28	FLbutton	" ",			1,    0,      4,     20,     20,    542, iy,  0,     9+$COUNT,    0,        0,    28
gk$COUNT,gih$COUNT_29	FLbutton	" ",			1,    0,      4,     20,     20,    562, iy,  0,     9+$COUNT,    0,        0,    29
gk$COUNT,gih$COUNT_30	FLbutton	" ",			1,    0,      4,     20,     20,    582, iy,  0,     9+$COUNT,    0,        0,    30
gk$COUNT,gih$COUNT_31	FLbutton	" ",			1,    0,      4,     20,     20,    602, iy,  0,     9+$COUNT,    0,        0,    31
gk$COUNT,gih$COUNT_32	FLbutton	" ",			1,    0,      4,     20,     20,    622, iy,  0,     9+$COUNT,    0,        0,    32
gk$COUNTGain, gih$COUNTGain		FLslider 	"",	0,      1,    0,    3,     -1,    100,      12,  642, iy+4
gk$COUNTPch, gih$COUNTPch		FLslider 	"",	25,   300,    0,    3,     -1,    100,      12,  842, iy+4
gk$COUNTDly, gih$COUNTDly		FLslider 	"",	0,     .1,    0,    3,     -1,    100,      12,  942, iy+4
;COUNTERS							MIN | MAX | STEP1 | STEP2 | TYPE | WIDTH | HEIGHT | POS_X | POS_Y | IOPCODE
gkLen$COUNT,gihLen$COUNT 		FLcount		"",	0,      8, 0.25,      1,     21,    100,     20,     742,    iy,      -1
gkphs$COUNT, gihtimpnt$COUNT		FLslider 	"",	0,      8,    0,      1,     -1,    625,      9,       8,    iy+18
FLsetColor2	0,255,0,gihtimpnt$COUNT

		FLsetVal_i	100, 	gih$COUNTPch
		FLsetVal_i	1, 	gih$COUNTGain
		FLsetVal_i	8, 	gihLen$COUNT
		iy	=	iy+30#

$ROW

#define	COUNT	#2#
$ROW

#define	COUNT	#3#
$ROW

#define	COUNT	#4#
$ROW

#define	COUNT	#5#
$ROW

#define	COUNT	#6#
$ROW

;VALUE DISPLAY BOXES
idRvbSnd	FLvalue	" ",      50,    15,     0, 255
idfblvl		FLvalue	" ",      50,    15,     0, 285
idfco		FLvalue	" ",      50,    15,     0, 315
gkRvbSnd, ihRvbSnd	FLslider 	"Reverb Send",		0,        1,   0,    3,     idRvbSnd,   235,    15,     0, 240
gkfblvl, ihfblvl	FLslider 	"Reverb Time",		0,        1,   0,    3,      idfblvl,   235,    15,     0, 270
gkfco, ihfco		FLslider 	"Reverb Filter Cutoff",	20,   20000,   0,    3,        idfco,   235,    15,     0, 300

		FLsetVal_i	0.4, 	ihRvbSnd
		FLsetVal_i	.7, 	ihfblvl
		FLsetVal_i	10000, 	ihfco
		FLsetVal_i	220, 	ihTempo
		FLsetVal_i	.5, 	ihMasterGain
		FLpanel_end	;END OF PANEL CONTENTS

;INSTRUCTIONS AND INFO PANEL
				FLpanel	" ",1045, 300, 0, 380
;TEXT BOXES																				TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                                   Looping Sequencer With Individually Variable Length Loops                                      ", 	1,      5,     14,    1040,    15,    5,   0
ih		 	FLbox  	"----------------------------------------------------------------------------------------------------------------------------------", 	1,      5,     14,    1040,    15,    5,  20
ih		 	FLbox  	"This example expands on the design from the 'Simple Drum Sequencer' example. Besides expanding the basic loop length to 8 beats   ", 	1,      5,     14,    1040,    15,    5,  40
ih		 	FLbox  	"(32 semiquavers) the principle innovation is that the user can shorten the range of the loop for each sound. The moving green bars", 	1,      5,     14,    1040,    15,    5,  60
ih		 	FLbox  	"representing current loop position for each sound should help clarify exactly what is happening. Each beat is divided into four   ", 	1,      5,     14,    1040,    15,    5,  80
ih		 	FLbox  	"semiquavers so that 0.25 in the 'Cycle Length' value represents 1 semiquaver, a value of 1 represents 1 beat.                     ", 	1,      5,     14,    1040,    15,    5, 100
ih		 	FLbox  	"If changes are made to the cycle lengths, the changed loop will probably not be in metrical sync. with the other. To resync. the  ", 	1,      5,     14,    1040,    15,    5, 120
ih	  	 	FLbox  	"loops turn the instrument off and on. Of course, lack of metrical sync may be desirable, which is the reason they do not resync.  ", 	1,      5,     14,    1040,    15,    5, 140
ih		 	FLbox  	"automatically. Notes that are outside the range of the loop for that sound will not be played.                                    ", 	1,      5,     14,    1040,    15,    5, 160
ih		 	FLbox  	"The sounds produced are kalimba-like sounds produced using Stefan Bilbao's 'barmodel' physical model. The pitch of each of the six", 	1,      5,     14,    1040,    15,    5, 180
ih		 	FLbox  	"sounds can be modified using the transpose sliders, they can be randomised on mass using the 'Randomise Pitches' button and are   ", 	1,      5,     14,    1040,    15,    5, 200
ih		 	FLbox  	"in fact randomised automatically upon startup.                                                                                    ", 	1,      5,     14,    1040,    15,    5, 220
ih		 	FLbox  	"The 'Delay' sliders allow each sound to be individually delayed by a small amount with respect to the others. This is intended to ", 	1,      5,     14,    1040,    15,    5, 240
ih		 	FLbox  	"allow the creation of 'flam'-like gestures.                                                                                       ", 	1,      5,     14,    1040,    15,    5, 260
ih		 	FLbox  	"A reverb effect (making use of the 'reverbsc' opcode) is included.                                                                ", 	1,      5,     14,    1040,    15,    5, 280

				FLpanel_end

		FLrun		;RUN THE WIDGET THREAD!


;FUNCTION TABLE FOR STORAGE OF SEQUENCE DATA FOR SOUND 1
gi1		ftgen		0,0,256,-2,	0,	0.25,	.001,	0,\
						0,	0.5,	.001,	0,\
						0,	0.75,	.001,	0,\
						0,	1,	.001,	0,\
						0,	1.25,	.001,	0,\
						0,	1.5,	.001,	0,\
						0,	1.75,	.001,	0,\
						0,	2,	.001,	0,\
						0,	2.25,	.001,	0,\
						0,	2.5,	.001,	0,\
						0,	2.75,	.001,	0,\
						0,	3,	.001,	0,\
						0,	3.25,	.001,	0,\
						0,	3.5,	.001,	0,\
						0,	3.75,	.001,	0,\
						0,	4,	.001,	0,\
						0,	4.25,	.001,	0,\
						0,	4.5,	.001,	0,\
						0,	4.75,	.001,	0,\
						0,	5,	.001,	0,\
						0,	5.25,	.001,	0,\
						0,	5.5,	.001,	0,\
						0,	5.75,	.001,	0,\
						0,	6,	.001,	0,\
						0,	6.25,	.001,	0,\
						0,	6.5,	.001,	0,\
						0,	6.75,	.001,	0,\
						0,	7,	.001,	0,\
						0,	7.25,	.001,	0,\
						0,	7.5,	.001,	0,\
						0,	7.75,	.001,	0,\
						0,	8,	.001,	0,\
						-1,	8,	-1,	-1

gi2		ftgen		0,0,256,-2,0	;EMPTY TABLES INITIALLY. CONTENTS WILL BE COPIED FROM TABLE gi01
gi3		ftgen		0,0,256,-2,0	;EMPTY TABLES INITIALLY. CONTENTS WILL BE COPIED FROM TABLE gi01
gi4		ftgen		0,0,256,-2,0	;EMPTY TABLES INITIALLY. CONTENTS WILL BE COPIED FROM TABLE gi01
gi5		ftgen		0,0,256,-2,0	;EMPTY TABLES INITIALLY. CONTENTS WILL BE COPIED FROM TABLE gi01
gi6		ftgen		0,0,256,-2,0	;EMPTY TABLES INITIALLY. CONTENTS WILL BE COPIED FROM TABLE gi01

zakinit	8,8		;INITIALISE ZAK SPACE (8 A-RATE, 8 K-RATE)
giRvbSndChn	=	1	;ZAK CHANNEL NUMBER USED FOR REVERB SEND

		instr	1	; NOTE TRIGGERING INSTRUMENT
if	gkOnOff!=0	goto	CONTINUE
turnoff
CONTINUE:

kTempoRatio	=	gkTempo/60

kp1		init	0
kp2		init	0
kp3		init	0
kp4		init	0

#define	LOOP	#kphs$COUNT    	phasor  (kTempoRatio)/gkLen$COUNT
gktimpnt$COUNT 	=        kphs$COUNT * gkLen$COUNT
ktrig   timedseq gktimpnt$COUNT,gi$COUNT, kp1, kp2,kp3, kp4
;	schedkwhen ktrigger, kmintim, kmaxnum, kinsnum,    kwhen,      kdur    p4    p5
	schedkwhen ktrig,       0,        0,     2,     gk$COUNTDly,   kp3,   kp4, $COUNT#

#define	COUNT	#1#
$LOOP

#define	COUNT	#2#
$LOOP

#define	COUNT	#3#
$LOOP

#define	COUNT	#4#
$LOOP

#define	COUNT	#5#
$LOOP

#define	COUNT	#6#
$LOOP

        endin

	instr	2
if	p4=1	then
	event_i	"i", p1+p5, 0, p3
endif
	endin

instr	3	;SOUND 1
	p3	=	2.6		;DEFINE DURATION FOR THIS SOUND
	asig 	barmodel	1, 1, i(gk1Pch), 1, 0, 2.6, 0.5, 1000, 0.07	;KALIMBA SOUND CREATED USING barmodel OPCODE (SEE CSOUND MANUAL FOR MORE INFO.)
	asigL	=	asig*i(gk1Gain)*i(gkMasterGain)*2	;DEFINE LEFT CHANNEL AUDIO
	asigR	=	asig*i(gk1Gain)*i(gkMasterGain)*2	;DEFINE RIGHT CHANNEL AUDIO
		outs	asigL, asigR 	;SEND AUDIO TO OUTPUTS
	zawm	asigL*gkRvbSnd, giRvbSndChn
	zawm	asigR*gkRvbSnd, giRvbSndChn+1
endin

instr	4	;SOUND 2
	p3	=	2.6		;DEFINE DURATION FOR THIS SOUND
	asig 	barmodel	1, 1, i(gk2Pch), 1, 0, 2.6, 0.5, 1000, 0.07	;KALIMBA SOUND CREATED USING barmodel OPCODE (SEE CSOUND MANUAL FOR MORE INFO.)
	asigL	=	asig*i(gk2Gain)*i(gkMasterGain)*2	;DEFINE LEFT CHANNEL AUDIO
	asigR	=	asig*i(gk2Gain)*i(gkMasterGain)*2	;DEFINE RIGHT CHANNEL AUDIO
		outs	asigL, asigR 	;SEND AUDIO TO OUTPUTS
	zawm	asigL*gkRvbSnd, giRvbSndChn
	zawm	asigR*gkRvbSnd, giRvbSndChn+1
endin

instr	5	;SOUND 3
	p3	=	2.6		;DEFINE DURATION FOR THIS SOUND
	asig 	barmodel	1, 1, i(gk3Pch), 1, 0, 2.6, 0.5, 1000, 0.07	;KALIMBA SOUND CREATED USING barmodel OPCODE (SEE CSOUND MANUAL FOR MORE INFO.)
	asigL	=	asig*i(gk3Gain)*i(gkMasterGain)*2	;DEFINE LEFT CHANNEL AUDIO
	asigR	=	asig*i(gk3Gain)*i(gkMasterGain)*2	;DEFINE RIGHT CHANNEL AUDIO
		outs	asigL, asigR 	;SEND AUDIO TO OUTPUTS
	zawm	asigL*gkRvbSnd, giRvbSndChn
	zawm	asigR*gkRvbSnd, giRvbSndChn+1
endin

instr	6	;SOUND 4
	p3	=	2.6		;DEFINE DURATION FOR THIS SOUND
	asig 	barmodel	1, 1, i(gk4Pch), 1, 0, 2.6, 0.5, 1000, 0.07	;KALIMBA SOUND CREATED USING barmodel OPCODE (SEE CSOUND MANUAL FOR MORE INFO.)
	asigL	=	asig*i(gk4Gain)*i(gkMasterGain)*2	;DEFINE LEFT CHANNEL AUDIO
	asigR	=	asig*i(gk4Gain)*i(gkMasterGain)*2	;DEFINE RIGHT CHANNEL AUDIO
		outs	asigL, asigR 	;SEND AUDIO TO OUTPUTS
	zawm	asigL*gkRvbSnd, giRvbSndChn
	zawm	asigR*gkRvbSnd, giRvbSndChn+1
endin

instr	7	;SOUND 5
	p3	=	2.6		;DEFINE DURATION FOR THIS SOUND
	asig 	barmodel	1, 1, i(gk5Pch), 1, 0, 2.6, 0.5, 1000, 0.07	;KALIMBA SOUND CREATED USING barmodel OPCODE (SEE CSOUND MANUAL FOR MORE INFO.)
	asigL	=	asig*i(gk5Gain)*i(gkMasterGain)*2	;DEFINE LEFT CHANNEL AUDIO
	asigR	=	asig*i(gk5Gain)*i(gkMasterGain)*2	;DEFINE RIGHT CHANNEL AUDIO
		outs	asigL, asigR 	;SEND AUDIO TO OUTPUTS
	zawm	asigL*gkRvbSnd, giRvbSndChn
	zawm	asigR*gkRvbSnd, giRvbSndChn+1
endin

instr	8	;SOUND 6
	p3	=	2.6		;DEFINE DURATION FOR THIS SOUND
	asig 	barmodel	1, 1,i(gk6Pch), 1, 0, 2.6, 0.5, 1000, 0.07	;KALIMBA SOUND CREATED USING barmodel OPCODE (SEE CSOUND MANUAL FOR MORE INFO.)
	asigL	=	asig*i(gk6Gain)*i(gkMasterGain)*2	;DEFINE LEFT CHANNEL AUDIO
	asigR	=	asig*i(gk6Gain)*i(gkMasterGain)*2	;DEFINE RIGHT CHANNEL AUDIO
		outs	asigL, asigR 	;SEND AUDIO TO OUTPUTS
	zawm	asigL*gkRvbSnd, giRvbSndChn
	zawm	asigR*gkRvbSnd, giRvbSndChn+1
endin

;;;	WRITE CHANGED FL-GRID VALUES TO TABLE
	instr	10
	tableiw	i(gk1), ((p4-1)*4)+3, gi1 	
	endin

	instr	11
	tableiw	i(gk2), ((p4-1)*4)+3, gi2 	
	endin

	instr	12
	tableiw	i(gk3), ((p4-1)*4)+3, gi3 	
	endin

	instr	13
	tableiw	i(gk4), ((p4-1)*4)+3, gi4
	endin

	instr	14
	tableiw	i(gk5), ((p4-1)*4)+3, gi5 	
	endin

	instr	15
	tableiw	i(gk6), ((p4-1)*4)+3, gi6 	
	endin

instr	100	;COPY TABLE 1 TO ALL OTHER TABLES AND SET RANDOM INITIAL VALUES FOR SOME VALUATORS (PERFORMED ONCE AT THE BEGINNING OF THE PERFORMANCE)
	tableicopy gi2, gi1
	tableicopy gi3, gi1
	tableicopy gi4, gi1
	tableicopy gi5, gi1
	tableicopy gi6, gi1
	event_i	"i", 102, 0,0.001	;RANDOMISE SLIDERS
endin

instr	102	;RANDOMISE SLIDERS
iPch1	random		25,300		;DEFINE RANDOM INITIAL VALUES FOR 'TRANSPOSE' SLIDERS
iPch2	random		25,300	        ;DEFINE RANDOM INITIAL VALUES FOR 'TRANSPOSE' SLIDERS
iPch3	random		25,300	        ;DEFINE RANDOM INITIAL VALUES FOR 'TRANSPOSE' SLIDERS
iPch4	random		25,300	        ;DEFINE RANDOM INITIAL VALUES FOR 'TRANSPOSE' SLIDERS
iPch5	random		25,300	        ;DEFINE RANDOM INITIAL VALUES FOR 'TRANSPOSE' SLIDERS
iPch6	random		25,300	        ;DEFINE RANDOM INITIAL VALUES FOR 'TRANSPOSE' SLIDERS
	FLsetVal_i	iPch1, gih1Pch	;SEND RANDOM 'TRANSPOSE' VALUES TO SLIDERS
	FLsetVal_i	iPch2, gih2Pch  ;SEND RANDOM 'TRANSPOSE' VALUES TO SLIDERS
	FLsetVal_i	iPch3, gih3Pch  ;SEND RANDOM 'TRANSPOSE' VALUES TO SLIDERS
	FLsetVal_i	iPch4, gih4Pch  ;SEND RANDOM 'TRANSPOSE' VALUES TO SLIDERS
	FLsetVal_i	iPch5, gih5Pch  ;SEND RANDOM 'TRANSPOSE' VALUES TO SLIDERS
	FLsetVal_i	iPch6, gih6Pch  ;SEND RANDOM 'TRANSPOSE' VALUES TO SLIDERS
;;;;UNCOMMENT THE FOLLOWING CODE IF YOU WANT CYCLE LENGTHS TO BE RANDOMIZED AT STARTUP;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;iLen1Dec	random		1,5					;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen1Int	random		4,8                                     ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen1		=		(int(iLen1Dec)*0.25)+int(iLen1Int)      ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen2Dec	random		1,5                                     ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen2Int	random		4,8                                     ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen2		=		(int(iLen2Dec)*0.25)+int(iLen2Int)      ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen3Dec	random		1,5                                     ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen3Int	random		4,8                                     ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen3		=		(int(iLen3Dec)*0.25)+int(iLen3Int)      ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen4Dec	random		1,5                                     ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen4Int	random		4,8                                     ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen4		=		(int(iLen4Dec)*0.25)+int(iLen4Int)      ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen5Dec	random		1,5                                     ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen5Int	random		4,8                                     ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen5		=		(int(iLen5Dec)*0.25)+int(iLen5Int)      ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen6Dec	random		1,5                                     ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen6Int	random		4,8                                     ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;iLen6		=		(int(iLen6Dec)*0.25)+int(iLen6Int)      ;DEFINE RANDOM INITIAL VALUES FOR 'RANGE' COUNTERS
;;;;	FLsetVal_i	iLen1, gihLen1				;SEND RANDOM 'RANGE' VALUES TO COUNTERS
;;;;	FLsetVal_i	iLen2, gihLen2                          ;SEND RANDOM 'RANGE' VALUES TO COUNTERS
;;;;	FLsetVal_i	iLen3, gihLen3                          ;SEND RANDOM 'RANGE' VALUES TO COUNTERS
;;;;	FLsetVal_i	iLen4, gihLen4                          ;SEND RANDOM 'RANGE' VALUES TO COUNTERS
;;;;	FLsetVal_i	iLen5, gihLen5                          ;SEND RANDOM 'RANGE' VALUES TO COUNTERS
;;;;	FLsetVal_i	iLen6, gihLen6                          ;SEND RANDOM 'RANGE' VALUES TO COUNTERS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	endin

	instr	101	;STORE PATTERN 1
iflag	=	1	;0=BINARY NON-ZERO=TEXT
ftsave "Pattern01", iflag, gi1, gi2, gi3, gi4, gi5, gi6
	endin
	

instr 	999		;REVERB
aL	zar		giRvbSndChn
aR	zar		giRvbSndChn+1
	denorm		aL, aR	;DENORMALIZE BOTH CHANNELS OF AUDIO SIGNAL
	arvbL, arvbR 	reverbsc 	aL, aR, gkfblvl, gkfco, sr;, i(gkpitchm), i(gkskip) 
	outs		arvbL, arvbR
	zacl		1,8
endin
	
instr	1000	;UPDATE LOOP INDICATORS
	ktrigger	metro	20
	FLsetVal	ktrigger, gktimpnt1, gihtimpnt1
	FLsetVal	ktrigger, gktimpnt2, gihtimpnt2
	FLsetVal	ktrigger, gktimpnt3, gihtimpnt3
	FLsetVal	ktrigger, gktimpnt4, gihtimpnt4
	FLsetVal	ktrigger, gktimpnt5, gihtimpnt5
	FLsetVal	ktrigger, gktimpnt6, gihtimpnt6
endin

</CsInstruments>

<CsScore>
f 0 3600
i 100 0 0
i 999 0 3600
i 1000 0 3600	;LOOP INDICATORS
</CsScore>

</CsoundSynthesizer>
