;; -*- cscsd-current-processing : "csound to dac" -*-
<About> ===================================================================

This demo, to be used within Emacs in Surmulot, demonstrates the interactive
manipulation of variables via OSC-driven graphical controls.

At the moment, only plain sliders are available.

   show controls: [[elisp:(surmulot-widget-OSC-controls)]]
   or select "Show OSC controls" in the "Widgets" menu

================================================================== </About>

<CsoundSynthesizer>
<CsOptions>
-dodac
</CsOptions>

<CsInstruments>

  sr	    =  44100
  ksmps	    =  10
  nchnls    =  1

#include "surmulot-OSC.orc"

instr   1

  $OSCSLIDER(kfp'440'220'1000)
  $OSCSLIDER(kfm'50'1'200)
  amod	    oscil     1, kfm,1
  aout	    oscil     10000, kfp*amod, 1
	    out	      aout
endin
        
</CsInstruments>

<CsScore>
; Table #1, a sine wave.
f 1 0 1024 10 1

i1 0 3600
</CsScore>
</CsoundSynthesizer>
