<CsoundSynthesizer>

<CsOptions>
-odevaudio -d -b1000
</CsOptions>

<CsInstruments>
sr 			= 		44100
ksmps 			= 		5
nchnls 			= 		2

			FLpanel	"Additive Synthesis Spectrum Sketching", 1300, 680, 0, 0

ix	=	50

;XY PANELS				MINX | MAXX | MINY | MAXY | EXPX | EXPY | DISPX | DISPY | WIDTH | HEIGHT | X | Y
gkx, gky, ihx, ihy	FLjoy	"",	0,      30,    1,     0,      0,    0,     -1,     -1,   1200,    300,    ix,  0

;SLIDERS							MIN | MAX | EXP | TYPE | DISP  | WIDTH | HEIGHT | X | Y
iwidth	=	40
itype	=	2
iRatio	=	1

#define	FLTK_FOR_PARTIAL #gkPartAmp$COUNT,  gihPartAmp$COUNT	FLslider 	"$COUNT",0,    1,    0,  itype,    -1,   iwidth,    245,   ix, 300
gkRatio$COUNT, ihRatio$COUNT		FLtext		"",     .125, 20,  .01,  1,              iwidth,     20,   ix, 560
FLsetVal_i	1, 	gihPartAmp$COUNT
FLsetVal_i	iRatio, ihRatio$COUNT 
iRatio	=	iRatio + 1
ix	=	ix+iwidth#

;FLcolor	0, 0, 0	;BLACK

#define	COUNT	#1#
$FLTK_FOR_PARTIAL

#define	COUNT	#2#
$FLTK_FOR_PARTIAL

#define	COUNT	#3#
$FLTK_FOR_PARTIAL

#define	COUNT	#4#
$FLTK_FOR_PARTIAL

#define	COUNT	#5#
$FLTK_FOR_PARTIAL

#define	COUNT	#6#
$FLTK_FOR_PARTIAL

#define	COUNT	#7#
$FLTK_FOR_PARTIAL

#define	COUNT	#8#
$FLTK_FOR_PARTIAL

#define	COUNT	#9#
$FLTK_FOR_PARTIAL

#define	COUNT	#10#
$FLTK_FOR_PARTIAL

#define	COUNT	#11#
$FLTK_FOR_PARTIAL

#define	COUNT	#12#
$FLTK_FOR_PARTIAL

#define	COUNT	#13#
$FLTK_FOR_PARTIAL

#define	COUNT	#14#
$FLTK_FOR_PARTIAL

#define	COUNT	#15#
$FLTK_FOR_PARTIAL

#define	COUNT	#16#
$FLTK_FOR_PARTIAL

#define	COUNT	#17#
$FLTK_FOR_PARTIAL

#define	COUNT	#18#
$FLTK_FOR_PARTIAL

#define	COUNT	#19#
$FLTK_FOR_PARTIAL

#define	COUNT	#20#
$FLTK_FOR_PARTIAL

#define	COUNT	#21#
$FLTK_FOR_PARTIAL

#define	COUNT	#22#
$FLTK_FOR_PARTIAL

#define	COUNT	#23#
$FLTK_FOR_PARTIAL

#define	COUNT	#24#
$FLTK_FOR_PARTIAL

#define	COUNT	#25#
$FLTK_FOR_PARTIAL

#define	COUNT	#26#
$FLTK_FOR_PARTIAL

#define	COUNT	#27#
$FLTK_FOR_PARTIAL

#define	COUNT	#28#
$FLTK_FOR_PARTIAL

#define	COUNT	#29#
$FLTK_FOR_PARTIAL

#define	COUNT	#30#
$FLTK_FOR_PARTIAL

;TEXT BOXES					TYPE | FONT | SIZE | WIDTH | HEIGHT | X |  Y
ih		 	FLbox  	"Freq. Ratios",	1,       5,    12,     50,     30,   0,  560

;VALUE DISPLAY BOXES					WIDTH | HEIGHT | X |  Y
idFundFrq			FLvalue	" ",     	60,       20,   50,   630

;					            					MIN  | MAX | EXP | TYPE |   DISP      | WIDTH | HEIGHT | X | Y
gkFundFrq, ihFundFrq		FLslider 	"Fundemental Frequency",		 4,   8000,  -1,    3,   idFundFrq,      500,    30,    50, 600


FLsetVal_i	100, 	ihFundFrq
FLsetVal_i	0, 	ihx
FLsetVal_i	0, 	ihy

FLpanel_end	;END OF PANEL CONTENTS

;INSTRUCTIONS AND INFO PANEL
				FLpanel	" ", 500, 320, 100, 100
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"       additive synthesis - partial strength sketching       ", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"One of the drawbacks of additive synthesis is the vast number", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"parameters that must be defined in the synthesis of a sound  ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"of any complexity. This can be a slow and unspontaneous      ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"process.                                                     ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"This example suggests a method in which slider values for    ", 	1,      5,     14,    490,    15,     5, 120
ih	  	 	FLbox  	"partial amplitudes can be sketched in sweeping movements of  ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"the mouse rather than having to be dragged up or down one by ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"one.                                                         ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"Sketching is done on the FLjoy panel at the top of the GUI.  ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"The sliders below this, display the current values for all   ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	"partials but adjusting these sliders themselves will have no ", 	1,      5,     14,    490,    15,     5, 240
ih		 	FLbox  	"effect.                                                      ", 	1,      5,     14,    490,    15,     5, 260
ih		 	FLbox  	"This example makes extensive use of macros in order to       ", 	1,      5,     14,    490,    15,     5, 280
ih		 	FLbox  	"avoid lengthy repetitions of code.                           ", 	1,      5,     14,    490,    15,     5, 300

				FLpanel_end

FLrun		;RUN THE WIDGET THREAD!

gisine			ftgen		0,0,4096,10,1
giwaveform		ftgen		0,0,32,-2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1

instr		1
	kx			=		int(gkx)
	ktrigger		changed		kx, gky
	kamp			=		200
	;	SCHEDKWHEN KTRIGGER, KMINTIM, KMAXNUM, KINSNUM, KWHEN, KDUR, p4,  p5
		schedkwhen ktrigger,    0,       0,     p1+1,     0,    0,   gkx, gky
	iporttime		=		0.02
	kporttime		linseg		0,0.001,iporttime,1,iporttime
	kfund			portk		gkFundFrq, kporttime
	amix			init		0
#define	OSCILLATOR	#kPartAmp$COUNT 		table		$COUNT-1, giwaveform
	kPartAmp$COUNT 		portk		kPartAmp$COUNT , kporttime
	ktrigger		changed		kPartAmp$COUNT
				FLsetVal	ktrigger, kPartAmp$COUNT, gihPartAmp$COUNT
	apart$COUNT	oscil	kamp*(1-kPartAmp$COUNT),  kfund+(kfund*gkRatio$COUNT), gisine
	amix		=	amix + apart$COUNT#
#define			COUNT		#1#
	$OSCILLATOR
#define			COUNT		#2#
	$OSCILLATOR
#define			COUNT		#3#
	$OSCILLATOR
#define			COUNT		#4#
	$OSCILLATOR
#define			COUNT		#5#
	$OSCILLATOR
#define			COUNT		#6#
	$OSCILLATOR
#define			COUNT		#7#
	$OSCILLATOR
#define			COUNT		#8#
	$OSCILLATOR
#define			COUNT		#9#
	$OSCILLATOR
#define			COUNT		#10#
	$OSCILLATOR
#define			COUNT		#11#
	$OSCILLATOR
#define			COUNT		#12#
	$OSCILLATOR
#define			COUNT		#13#
	$OSCILLATOR
#define			COUNT		#14#
	$OSCILLATOR
#define			COUNT		#15#
	$OSCILLATOR
#define			COUNT		#16#
	$OSCILLATOR
#define			COUNT		#17#
	$OSCILLATOR
#define			COUNT		#18#
	$OSCILLATOR
#define			COUNT		#19#
	$OSCILLATOR
#define			COUNT		#20#
	$OSCILLATOR
#define			COUNT		#21#
	$OSCILLATOR
#define			COUNT		#22#
	$OSCILLATOR
#define			COUNT		#23#
	$OSCILLATOR
#define			COUNT		#24#
	$OSCILLATOR
#define			COUNT		#25#
	$OSCILLATOR
#define			COUNT		#26#
	$OSCILLATOR
#define			COUNT		#27#
	$OSCILLATOR
#define			COUNT		#28#
	$OSCILLATOR
#define			COUNT		#29#
	$OSCILLATOR
#define			COUNT		#30#
	$OSCILLATOR
	outs	amix, amix	;SEND MIXED SIGNAL TO THE OUTPUTS
	amix	=	0
endin

instr	2
	tableiw	p5, p4, giwaveform			
endin
				
</CsInstruments>

<CsScore>
i 1 0 3600
</CsScore>

</CsoundSynthesizer>